/* social.h: transmit messages over pipes */

#ifndef SOCIAL_H
#define SOCIAL_H

#include <time.h>

/* keep track of up to friends (3) of friends (2) of friends (1)
 * indices are 0 (for friends), 1 (friends of friends), 2 (friends of friends
 * of friends)
 */
#define MAX_SOCIAL_TIER         3
#define COMPLETE_STRANGER       (MAX_SOCIAL_TIER * 2)

/* opaque type used to store social information */
/* struct social_info; */

extern struct social_info * init_social (int max_bytes);

extern time_t update_social (struct social_info * soc, int update_seconds);

extern int social_connection (struct social_info * soc, char * dest, int bits);

#endif /* SOCIAL_H */
