
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../pipemsg.h"

int main (int argc, char ** argv)
{
  int pipefd [2];

  if (pipe (pipefd) < 0) {
    perror ("pipe");
    return 0;
  }
  add_pipe (pipefd [0]);

  char message [] = "hello world";
  int pri = 565;
  printf ("send_pipe_message (%d, %s, %zd, %d)\n",
          pipefd [1], message, strlen (message), pri);
  if (! send_pipe_message (pipefd [1], message, strlen (message), pri)) {
    printf ("error in send_pipe_message (%d, %s, %zd, %d)\n",
            pipefd [1], message, strlen (message), pri);
    return 0;
  }
  char * rmessage;
  printf ("receive_pipe_message (%d, %p, %p)\n", pipefd [0], &rmessage, &pri);
  int r = receive_pipe_message (pipefd [0], &rmessage, &pri);
  if (r < 0) {
    printf ("error in receive_pipe_message (%d, %p, %p)\n",
            pipefd [0], &rmessage, &pri);
    return 0;
  }
  char result [sizeof (message) + 100];
  int copy = sizeof (result) - 1;
  if (r < copy) copy = r;
  memcpy (result, rmessage, copy);
  result [copy] = '\0';

  free (rmessage);

  if (copy == r)
    printf ("received message beginning with '%s', length %d, priority %d\n",
            result, r, pri);
  else
    printf ("received message '%s', length %d, priority %d\n", result, r, pri);
}

